AchSnd.MsgFrame = CreateFrame("Frame" , "AchSndMessageFrame", UIParent )
local me = AchSnd.MsgFrame
AchSnd.MBox={}
me:Hide()

local MOBuff = 5
local e = 0 -- elapsed time counter
local cdown = 0 -- auto cancel countdown
local fdelay = 0 -- Fade Countdown

local update= 1/10
local Backdrop={
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 32,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0
	}
}
	
me:EnableMouse(true)
me:SetPoint("CENTER", UIParent, "CENTER")
me:SetHeight( 125 )
me:SetWidth( 400 )
me:SetBackdrop( Backdrop )
me:SetBackdropColor( 128, 128,128, 1)
me:SetBackdropBorderColor( 255, 255, 255, 1)
me:SetMovable(true)
me:SetUserPlaced(true)
me:SetClampedToScreen(true)
	
me:SetScript("OnShow", function(self)
	--Set Frame Positon for future alerts
	if ((AchSnd_SettingsPC.AlertPosSet == 0) and (AchSnd_Settings.NewMsgBox == "on"))then
		me.Text:SetText( "Please move the \"Grats Alert Frame\" to where you would like it and close it to save its position (You can always move it again later by dragging the title box around)" )
		me.GratsButton:SetText("Click Me!")
		me.CancelButton:SetText("No, Click Me!")
		return
	end
	
	if ( AchSnd.MBox.mode == nil) then
		me:Hide()
		return
	end
	
	if (AchSnd_Settings.AutoFade == "off") then
		me:SetAlpha(1)
	end
	
	if (AchSnd.MBox.mode == "SAY") then
		me.GratsButton:SetText("Say Grats")
	elseif (AchSnd.MBox.mode == "PARTY") then
		me.GratsButton:SetText("Party Grats")
	elseif (AchSnd.MBox.mode == "GUILD") then
		me.GratsButton:SetText("Guild Grats")
	elseif (AchSnd.MBox.mode == "TEST") then
		me.GratsButton:SetText("TEST FRAME")
	else
		me.GratsButton:SetText("? Grats ?")
	end

	me.Text:SetText( AchSnd.MBox.text )
	me.CancelButton:SetText("Cancel")
	
	if (AchSnd.MBox.mode == "TEST") then
		cdown = AchSnd.panel.Timeout:GetValue()
		fdelay = AchSnd.panel.FadeDelay:GetValue()
	else
		cdown = AchSnd_Settings.Timeout
		fdelay = AchSnd_Settings.FadeDelay
	end
	
end)

me:SetScript("OnUpdate", function(self, elapsed)
	if (AchSnd_SettingsPC.AlertPosSet == 0) then
		return
	end

	e = e + elapsed
	if (e < update) then
		return
	end

	-- Items to be updated goes here
	if (AchSnd_Settings.NewMsgBox == "off") then
		me:Hide()
	end
	
	local AFchecked = AchSnd.panel.AutoFade:GetChecked()
	local testmode = AchSnd.MBox.mode == "TEST"	
	
	if ( testmode and AFchecked ) or (not(testmode) and AchSnd_Settings.AutoFade == "on") then
		fdelay = (fdelay - e)
		if (fdelay <= 0 ) then 
			if ((me:IsMouseOver(MOBuff, -MOBuff, -MOBuff, MOBuff)) or (me.TitleRegion:IsMouseOver(MOBuff, -MOBuff, -MOBuff, MOBuff))) then
				me:SetAlpha( 1 )
			else
				me:SetAlpha( testmode and AchSnd.panel.MinAlpha:GetValue() or AchSnd_Settings.MinAlpha )
			end
			fdelay = 0
		else
			me:SetAlpha( 1)
		end
	else
		me:SetAlpha( 1)
	end

	local MBT = AchSnd.panel.Timeout:GetValue()
	if (testmode and MBT ~= 0) or (not(testmode) and AchSnd.MsgBoxTimeout ~= 0) then
		cdown = (cdown - e)
		if (cdown > 0) then
			me.CancelButton:SetText( string.format("Cancel ( %i )", math.ceil(cdown)))
		elseif (cdown <= 0) then
			me:Hide()
			if (testmode) then
			--	GameMenuFrame:Show()
				InterfaceOptionsFrame:Show()
			end
			
		end
	end
		
	e=0
end)

-- Title region
me.TitleRegion = me:CreateTitleRegion()
me.TitleRegion:SetSize( 324, 64)
me.TitleRegion:SetPoint( "TOP", me, "TOP", 0,12)

-- Title frame header
me.TitleBkgnd=me:CreateTexture(nil , "ARTWORK")
me.TitleBkgnd:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
me.TitleBkgnd:SetSize( 324, 64)
me.TitleBkgnd:SetPoint( "TOP", me, "TOP", 0,12)

-- Title frame text
me.Title = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
me.Title:SetText("Achievement Sounds")
me.Title:SetPoint( "CENTER", me.TitleBkgnd, "CENTER", 0, 12 )
me.Title:SetJustifyH( "CENTER" )
me.Title:SetJustifyV( "MIDDLE" )

-- Box Text
me.Text = me:CreateFontString( nil , "OVERLAY", "GameFontHighlight")
--me.Text:SetText( me.BoxText )
me.Text:SetPoint( "TOP", me.TitleBkgnd, "TOP", 0, -16 )
me.Text:SetSize( 376, 100)
me.Text:SetJustifyH( "CENTER" )
me.Text:SetJustifyV( "MIDDLE" )

-- Grat Button
me.GratsButton = CreateFrame( "Button", "AchSndMsgBoxGratButton", me, "UIPanelButtonTemplate" )
me.GratsButton:SetPoint("CENTER", me, "BOTTOM", -85, 25)
me.GratsButton:SetSize( 150, 25)
--me.GratsButton:SetText("Grats")
me.GratsButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	me:Hide()
	-- Testing the frame
	if (AchSnd.MBox.mode == "TEST") then
		--GameMenuFrame:Show()
		InterfaceOptionsFrame:Show()
		return
	end
	
	-- Set Alert Box Position
	if (AchSnd_SettingsPC.AlertPosSet == 0) then
		AchSnd_SettingsPC.AlertPosSet = 1
		return
	end
	
	-- grats stuff goes here
	local mode = AchSnd.MBox.mode
	if (AchSnd_Settings.Random == "on") then
		SendChatMessage( AchSnd.RandMsg(mode) , mode)
	else
		SendChatMessage( AchSnd_Settings.DefaultMsg , mode )
	end
end)

-- Cancel Button
me.CancelButton = CreateFrame( "Button", "AchSndMsgBoxCancelButton", me, "UIPanelButtonTemplate" )
me.CancelButton:SetPoint("CENTER", me, "BOTTOM", 85, 25)
me.CancelButton:SetSize( 150, 25)
me.CancelButton:SetText("Cancel")
me.CancelButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	me:Hide()
	
	-- Testing the frame
	if (AchSnd.MBox.mode == "TEST") then
		--GameMenuFrame:Show()
		InterfaceOptionsFrame:Show()
		return
	end

	-- Set Alert Box position
	if (AchSnd_SettingsPC.AlertPosSet == 0) then
		AchSnd_SettingsPC.AlertPosSet = 1
		return
	end
	-- cancel stuff goes here
	
end)

